MantisBT  Site | Plugring | Plugins API and Macros | Forum | English Forum | Code

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0003408PluginsArclitepublic2017-03-14 19:062017-03-21 22:48
Reporterflowswitch 
Assigned ToDrKnS 
PrioritynormalSeverityminorReproducibilityrandom
StatusclosedResolutionfixed 
Platformx64OSWindowsOS Version8
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0003408: Arclite не закрывает файл после неуспешного распознавания формата
DescriptionУсловия:
Arclite настроен на открытие всего (маски неактивны)
"Подопытный" файл формата .idb (IDA Pro database) не является архивом по формату, расширение ассоциировано средствами Windows с соответствующим приложением.

Симптомы:
При нажатии <enter> на файле он открывается ассоциированным приложением (IDA). При попытке выйти с сохранением, IDA ругается на невозможность переименовать временный файл в тот, который открывали, и выходит. После этого Far показывает в папке оба файла - исходный и временный (с другим расширением), временный файл - нормальный (просматривается по F3 итд), исходный - "фантом" ("Отказано в доступе" на все операции с ним). После закрытия Far "фантом" пропадает.

Additional InformationProcess Monitor показывает, что IDA сначала сохраняет данные во временный файл, затем удаляет исходный (успешно), затем пытается переименовать временный в исходный и получает ошибку "файл уже существует". Просмотр открытых хэндлов процесса far.exe при уже открытом в IDA файле показывает незакрытый хэндл этого файла, принадлежащий Far.

Временное решение:
Внёс маску *.idb в исключения Arclite - проблема ушла, но по хорошему это - баг.
TagsNo tags attached.
Attached Filestxt file icon test.txt [^] (524,288 bytes) 2017-03-15 00:42

- Relationships

-  Notes
(0015275)
2useven10 (developer)
2017-03-14 20:32
edited on: 2017-03-14 20:34

Откуда уверенность, что файл держит arclite ?
Не 100%, но мне кажется, такого расширения в стандартных у arclite нет...
Если файл не секретный, приаттачте здесь для проверки.

(0015276)
flowswitch (reporter)
2017-03-15 01:04

Как сразу и писал, у меня отключены маски включения в настройках arclite (снята галка "Open files matching masks", мне так и нужно, 7z.dll поддерживает существенно больше форматов, нежели перечислено в стандартных масках). А добавление *.idb в маски исключения ("Exclude files matching masks") устраняет проблему - файл больше никто не держит. Включение "Open files matching masks" также устраняет проблему. Ну и запуск с отключёнными плагинами соответственно тоже.

Потестировал ещё - IDA ни при чём, важно только содержимое файла. Точно такой же эффект получил, переименовав файл в *.txt - он открылся в Блокноте, и handle (от Sysinternals который) так же показывает незакрытый Farом хэндл. После закрытия блокнота попытка удаления этого файла из Far также делает из него "фантом". Сам файл был довольно большой (307М), но первые 512К от него дают тот же результат (их и прикрепил). Меньший кусок (256К) уже проблемы не вызывает.
(0015277)
2useven10 (developer)
2017-03-15 02:01

Действительно, насекомые похоже есть.
Не факт что в arclite, хоть без него и не проявляется...
(0015278)
2useven10 (developer)
2017-03-15 10:14

> 7z.dll поддерживает существенно больше форматов, нежели перечислено в стандартных масках).
>
Для них есть Ctrll-PgDn, кстати, при этом ошибка похоже не проявляется.
(0015279)
DrKnS (administrator)
2017-03-15 15:32

252.
(0015280)
flowswitch (reporter)
2017-03-16 00:34

> Для них есть Ctrll-PgDn, кстати, при этом ошибка похоже не проявляется.
Про Ctrl-PgDn не знал, спасибо, так гораздо удобнее (в случае неудачи не отдаёт на открытие системе).

А ошибка проявляется точно так же. Нажал шесть раз подряд Ctrl-PgDn на том test.txt - шесть незакрытых хэндлов и "фантом" при удалении.
(0015281)
2useven10 (developer)
2017-03-16 00:54

> А ошибка проявляется точно так же.
>
Ошибку (мою \) DrKnS поправил. Проверяйте в следующей ночной сборке.

- Issue History
Date Modified Username Field Change
2017-03-14 19:06 flowswitch New Issue
2017-03-14 20:32 2useven10 Note Added: 0015275
2017-03-14 20:34 2useven10 Note Edited: 0015275 View Revisions
2017-03-15 00:42 flowswitch File Added: test.txt
2017-03-15 01:04 flowswitch Note Added: 0015276
2017-03-15 02:01 2useven10 Note Added: 0015277
2017-03-15 10:14 2useven10 Note Added: 0015278
2017-03-15 15:32 DrKnS Note Added: 0015279
2017-03-15 15:32 DrKnS Assigned To => DrKnS
2017-03-15 15:32 DrKnS Status new => feedback
2017-03-16 00:34 flowswitch Note Added: 0015280
2017-03-16 00:34 flowswitch Status feedback => assigned
2017-03-16 00:54 2useven10 Note Added: 0015281
2017-03-21 22:48 DrKnS Status assigned => closed
2017-03-21 22:48 DrKnS Resolution open => fixed
2017-03-21 22:48 DrKnS Fixed in Version => 3.0



Copyright © 2000 - 2017 MantisBT Team
Powered by Mantis Bugtracker